//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <inifiles.hpp>
#include <registry.hpp>
#include <stdio.h>
#include "UDemo.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

extern "C" DWORD __stdcall __declspec(dllimport) InitController(DWORD CMode,DWORD Axes,DWORD ComPort,DWORD Baudrate,HWND UserWin,UINT AsyncMsg,DWORD Mode);
extern "C" DWORD __stdcall __declspec(dllimport) OpenController(void);
extern "C" DWORD __stdcall __declspec(dllimport) ResetComm(void);
extern "C" DWORD __stdcall __declspec(dllimport) CloseController(void);
extern "C" DWORD __stdcall __declspec(dllimport) ExecuteCommand(LPSTR Command,DWORD LinesExpected,LPSTR Reply);
extern "C" DWORD __stdcall __declspec(dllimport) GetReply(LPSTR pReply);
extern "C" DWORD __stdcall __declspec(dllimport) AbortCommand(void);
extern "C" DWORD __stdcall __declspec(dllimport) SetDecimalSeparator(BYTE ucDecimalSep);
extern "C" DWORD __stdcall __declspec(dllimport) PreprocessReply(BYTE Active);

//specified venus commands
extern "C" DWORD __stdcall __declspec(dllimport) Calibrate(void);
extern "C" DWORD __stdcall __declspec(dllimport) CalibrateA(DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) ClearParameterStack(void);
extern "C" DWORD __stdcall __declspec(dllimport) ClearParameterStackA(DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetAcceleration(LPSTR Accel);
extern "C" DWORD __stdcall __declspec(dllimport) GetAccelerationA(LPSTR Accel,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetAxisMode(LPDWORD A1,LPDWORD A2,LPDWORD A3,LPDWORD A4);
extern "C" DWORD __stdcall __declspec(dllimport) GetAxisModeA(LPDWORD Value,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetError(LPDWORD Error);
extern "C" DWORD __stdcall __declspec(dllimport) GetErrorA(LPDWORD Error,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetJoystickVelocity(LPSTR JoyVel);
extern "C" DWORD __stdcall __declspec(dllimport) GetJoystickVelocityA(LPSTR JoyVel,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetLimits(LPSTR A1Min,LPSTR A1Max,LPSTR A2Min,LPSTR A2Max,LPSTR A3Min,LPSTR A3Max,LPSTR A4Min,LPSTR A4Max);
extern "C" DWORD __stdcall __declspec(dllimport) GetLimitsA(LPSTR Min,LPSTR Max,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetParamsOnStack(LPDWORD Value);
extern "C" DWORD __stdcall __declspec(dllimport) GetParamsOnStackA(LPDWORD Value,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetPos(LPSTR A1,LPSTR A2,LPSTR A3,LPSTR A4);
//extern "C" DWORD __stdcall __declspec(dllimport) GetPosA(LPSTR *pPos);
extern "C" DWORD __stdcall __declspec(dllimport) GetPosA(LPSTR Pos,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetPosAxis(DWORD Axis,LPSTR Pos);
extern "C" DWORD __stdcall __declspec(dllimport) GetStatus(LPDWORD Status);
extern "C" DWORD __stdcall __declspec(dllimport) GetStatusA(LPDWORD Status,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) GetVelocity(LPSTR Vel);
extern "C" DWORD __stdcall __declspec(dllimport) GetVelocityA(LPSTR Vel,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) Identify(LPSTR Id);
extern "C" DWORD __stdcall __declspec(dllimport) IdentifyA(LPSTR Id,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) JoystickDisable(void);
extern "C" DWORD __stdcall __declspec(dllimport) JoystickDisableA(DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) JoystickEnable(void);
extern "C" DWORD __stdcall __declspec(dllimport) JoystickEnableA(DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) MoveAbsolute(LPSTR A1,LPSTR A2,LPSTR A3,LPSTR A4);
extern "C" DWORD __stdcall __declspec(dllimport) MoveAbsoluteA(LPSTR Value,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) MoveAbsoluteAutoReply(LPSTR A1,LPSTR A2,LPSTR A3,LPSTR A4);
extern "C" DWORD __stdcall __declspec(dllimport) MoveAbsoluteAutoReplyA(LPSTR Value,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) MoveRelative(LPSTR A1,LPSTR A2,LPSTR A3,LPSTR A4);
extern "C" DWORD __stdcall __declspec(dllimport) MoveRelativeA(LPSTR Value,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) MoveRelativeAutoReply(LPSTR A1,LPSTR A2,LPSTR A3,LPSTR A4);
extern "C" DWORD __stdcall __declspec(dllimport) MoveRelativeAutoReplyA(LPSTR Value,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) RangeMeasure(void);
extern "C" DWORD __stdcall __declspec(dllimport) RangeMeasureA(DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) SetAcceleration(LPSTR Accel);
extern "C" DWORD __stdcall __declspec(dllimport) SetAccelerationA(LPSTR Accel,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) SetAxisMode(DWORD A1,DWORD A2,DWORD A3,DWORD A4);
extern "C" DWORD __stdcall __declspec(dllimport) SetAxisModeA(DWORD Value,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) SetJoystickVelocity(LPSTR JoyVel);
extern "C" DWORD __stdcall __declspec(dllimport) SetJoystickVelocityA(LPSTR JoyVel,DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) SetOrigin(void);
extern "C" DWORD __stdcall __declspec(dllimport) SetOriginA(DWORD Axis);
extern "C" DWORD __stdcall __declspec(dllimport) SetVelocity(LPSTR Vel);
extern "C" DWORD __stdcall __declspec(dllimport) SetVelocityA(LPSTR Vel,DWORD Axis);

int		nAxes=3;	//x, y, z axis
int		nTestAxis=1;
DWORD	dwBaudrate;

TFormWp2Demo *FormWp2Demo;

//---------------------------------------------------------------------------
__fastcall TFormWp2Demo::TFormWp2Demo(TComponent* Owner)
	: TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TFormWp2Demo::FormCreate(TObject */*Sender*/)
{
int			i;
AnsiString	strId;
TIniFile		*pMyIniFile;
nControllerMode=WP2_CONTROLLER_DEFAULT;
for (i=0;i<8;i++)
	pReply[i]=new char[256];

ClientHeight=Memo1->Top+Memo1->Height+Memo1->Left;
ClientWidth=ButtonClose->Left+ButtonClose->Width+ButtonOpen->Left;
ButtonOpen->Enabled=false;
ButtonClose->Enabled=false;
ButtonTest->Enabled=false;
EditCommand->Enabled=false;
ComboBoxPort->ItemIndex=1;
//GB	ComboBoxBaudrate->ItemIndex=1;
pMyIniFile=new TIniFile(ExtractFilePath(Application->ExeName)+"Wp2comm.ini");
//GB	if (pMyIniFile->ReadInteger("Startup","AlphaMode",0)!=0)
strId=pMyIniFile->ReadString("Startup","CMode","Default");
delete(pMyIniFile);
if ((strId=="Delta")||(strId=="Delta-PC"))
	{
	nControllerMode=WP2_CONTROLLER_DELTA;
	ComboBoxController->ItemIndex=1;
//GB	ComboBoxBaudrate->Enabled=false;
	CSpinEditAxes->MaxValue=4;
	CSpinEditAxes->Value=4;
	}
else if (strId=="Alpha")
	{
	nControllerMode=WP2_CONTROLLER_ALPHA;
	ComboBoxController->ItemIndex=2;
	CSpinEditAxes->Value=4;
	ButtonTest->Caption="Test axis 1";
	EditCommand->Text="1 nversion";
	}
else if (strId=="Taurus")
	{
	nControllerMode=WP2_CONTROLLER_TAURUS;
	ComboBoxController->ItemIndex=3;
	CSpinEditAxes->Value=1;
	CSpinEditAxes->Enabled=false;
	ButtonTest->Caption="Test";
	EditCommand->Text="1 nversion";
	}
else if (strId=="Pegasus")
	{
	nControllerMode=WP2_CONTROLLER_PEGASUS;
	ComboBoxController->ItemIndex=4;
	CSpinEditAxes->Value=4;
	ButtonTest->Caption="Test axis 1";
	EditCommand->Text="1 nversion";
	}
else if (strId=="Orion")
	{
	nControllerMode=WP2_CONTROLLER_ORION;
	ComboBoxController->ItemIndex=5;
	CSpinEditAxes->Value=4;
	ButtonTest->Caption="Test axis 1";
	EditCommand->Text="1 nversion";
	}
else if (strId=="Corvus")
	{
	nControllerMode=WP2_CONTROLLER_CORVUS;
	ComboBoxController->ItemIndex=6;
	CSpinEditAxes->MaxValue=3;
	CSpinEditAxes->Value=3;
	}
else
	{
	nControllerMode=WP2_CONTROLLER_DEFAULT;
	ComboBoxController->ItemIndex=0;
	CSpinEditAxes->MaxValue=3;
	CSpinEditAxes->Value=3;
	}
SetupComboBoxBaudrate(nControllerMode);
ActiveControl=ButtonInit;
}
//---------------------------------------------------------------------------

void __fastcall TFormWp2Demo::FormDestroy(TObject */*Sender*/)
{
int		i;
for (i=0;i<8;i++)
	{
	if (pReply[i])
		delete[](pReply[i]);
	}
}
//---------------------------------------------------------------------------

void __fastcall TFormWp2Demo::FormClose(TObject */*Sender*/, TCloseAction &/*Action*/)
{
if (ButtonClose->Enabled==true)
	CloseController();
}
//---------------------------------------------------------------------------

void __fastcall TFormWp2Demo::ButtonInitClick(TObject */*Sender*/)
{
DWORD	dwError;
DWORD	dwMode;
switch(ComboBoxController->ItemIndex)
	{
	case(1):nControllerMode=WP2_CONTROLLER_DELTA;break;
	case(2):nControllerMode=WP2_CONTROLLER_ALPHA;break;
	case(3):nControllerMode=WP2_CONTROLLER_TAURUS;break;
	case(4):nControllerMode=WP2_CONTROLLER_PEGASUS;break;
	case(5):nControllerMode=WP2_CONTROLLER_ORION;break;
	case(6):nControllerMode=WP2_CONTROLLER_CORVUS;break;
	default:nControllerMode=WP2_CONTROLLER_DEFAULT;
	}
//nControllerMode=0;			//use the value in Wp2Comm.ini section [Startup], item CMode=Delta, CMode=Alpha or CMode=Default
//dwMode=2308+1048576;
dwMode=1050884;
//dwMode=0xffffffff;	//use the value in Wp2Comm.ini
dwBaudrate=ComboBoxBaudrate->Items->Strings[ComboBoxBaudrate->ItemIndex].ToInt();
//dwBaudrate=0;		//use the value in Wp2Comm.ini
nAxes=CSpinEditAxes->Value;
dwError=InitController(
		(DWORD)nControllerMode,
		nAxes,
		ComboBoxPort->ItemIndex+1,
		dwBaudrate,
		Handle,
		WMU_ASYNCMSG,
		dwMode);
if (dwError)
	{
	ShowMessage(Format("InitController(%d,%d,%d,%d,%d) returned error %d",ARRAYOFCONST((nControllerMode,(int)nAxes,(int)ComboBoxPort->ItemIndex+1,(int)dwError,(int)dwBaudrate,(int)dwMode))));
	return;
	}
ButtonOpen->Enabled=true;
ActiveControl=ButtonOpen;
}
//---------------------------------------------------------------------------

void __fastcall TFormWp2Demo::ButtonOpenClick(TObject */*Sender*/)
{
DWORD		dwError;
AnsiString	strCaptionBk;
ComboBoxController->Enabled=false;
CSpinEditAxes->Enabled=false;
ComboBoxPort->Enabled=false;
ComboBoxBaudrate->Enabled=false;
strCaptionBk=ButtonOpen->Caption;
ButtonOpen->Caption="Please wait...";
dwError=OpenController();
ButtonOpen->Caption=strCaptionBk;
if (dwError)
	{
	ShowMessage(Format("OpenController returned error %d",ARRAYOFCONST(((int)dwError))));
	ComboBoxController->Enabled=true;
	CSpinEditAxes->Enabled=true;
	ComboBoxPort->Enabled=true;
	if (nControllerMode!=WP2_CONTROLLER_DELTA)
		ComboBoxBaudrate->Enabled=true;
	EditCommand->Enabled=false;
	if (ButtonTest->Visible==true)
		ButtonTest->Enabled=false;
	ButtonClose->Enabled=false;
	ActiveControl=ButtonOpen;
	return;
	}
ButtonOpen->Enabled=false;
ButtonClose->Enabled=true;
EditCommand->Enabled=true;
Memo1->Lines->Clear();
if (ButtonTest->Visible==true)
	{
	ButtonTest->Enabled=true;
	ActiveControl=ButtonTest;
	}
else
	ActiveControl=EditCommand;
}
//---------------------------------------------------------------------------

void __fastcall TFormWp2Demo::ButtonCloseClick(TObject */*Sender*/)
{
DWORD	dwError;
dwError=CloseController();
if (dwError==0)
	{
	ComboBoxController->Enabled=true;
	if (nControllerMode!=WP2_CONTROLLER_TAURUS)
		CSpinEditAxes->Enabled=true;
	ComboBoxPort->Enabled=true;
	if (nControllerMode!=WP2_CONTROLLER_DELTA)
		ComboBoxBaudrate->Enabled=true;
	ButtonOpen->Enabled=true;
	if (ButtonTest->Visible==true)
		ButtonTest->Enabled=false;
	ButtonClose->Enabled=false;
	EditCommand->Enabled=false;
	ActiveControl=ButtonOpen;
	}
}
//---------------------------------------------------------------------------

void __fastcall TFormWp2Demo::ButtonTestClick(TObject */*Sender*/)
{
ButtonTest->Enabled=false;
if (DoTest()==false)
	{
	ResetComm();
	if (ButtonOpen->Enabled==false)
		ShowMessage("Error processing test routine");
	}
if (ButtonOpen->Enabled==false)
	{
	ButtonTest->Enabled=true;
	}
}
//---------------------------------------------------------------------------

bool TFormWp2Demo::DoTest()
{
bool			bSuccess;
AnsiString	strCaption;
if ((nControllerMode==WP2_CONTROLLER_ALPHA)
		||(nControllerMode==WP2_CONTROLLER_TAURUS)
		||(nControllerMode==WP2_CONTROLLER_PEGASUS)
		||(nControllerMode==WP2_CONTROLLER_ORION))
	{
	bSuccess=DoAlphaTest(nTestAxis);
	if ((bSuccess==true)
			&&(nControllerMode!=WP2_CONTROLLER_TAURUS))
		{
		if (nTestAxis<nAxes)
			nTestAxis++;
		else
			nTestAxis=1;
		ButtonTest->Caption=Format("Test axis %d",ARRAYOFCONST((nTestAxis)));
		}
	}
else
	{
	bSuccess=DoDefaultTest();
	}
return(bSuccess);
}

bool TFormWp2Demo::DoDefaultTest()
{
int		i;
DWORD	dwError;
DWORD	dwMode;
for (i=0;i<4;i++)
	dwValue[i]=0;

Memo1->Lines->Add("Processing ClearParameterStack() ...");
if (ClearParameterStack())
	return(false);
Memo1->Lines->Add("Done");

if (nControllerMode!=WP2_CONTROLLER_DELTA)
//not available for Delta-PC
	{
	Memo1->Lines->Add("Processing GetParamsOnStack() ...");
	if (GetParamsOnStack(&dwValue[0]))
		return(false);
	Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));
	}

Memo1->Lines->Add("Processing Identify() ...");
if (Identify(pReply[0]))
	return(false);
Memo1->Lines->Add(pReply[0]);

Memo1->Lines->Add("Processing GetStatus() ...");
if (GetStatus(&dwValue[0]))
	return(false);
Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));

Memo1->Lines->Add("Processing GetError() ...");
if (GetError(&dwValue[0]))
	return(false);
Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));

//SetAxisMode()
//activate some axes
for (i=0;i<nAxes-1;i++)
	{
	if ((i==nAxes-1)&&(nAxes>1))
		dwValue[i]=0;
	else
		dwValue[i]=1;
	}
Memo1->Lines->Add(Format("Processing SetAxisMode(%d,%d,%d,%d) ...",ARRAYOFCONST(((int)dwValue[0],(int)dwValue[1],(int)dwValue[2],(int)dwValue[3]))));
if (SetAxisMode(dwValue[0],dwValue[1],dwValue[2],dwValue[3]))
	return(false);
Memo1->Lines->Add("Done");

//GetAxisMode()
Memo1->Lines->Add("Processing GetAxisMode() ...");
if (nAxes==1)
	{
	if (GetAxisMode(&dwValue[0],NULL,NULL,NULL))
		return(false);
	Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));
	}
else if (nAxes==2)
	{
	if (GetAxisMode(&dwValue[0],&dwValue[1],NULL,NULL))
		return(false);
	Memo1->Lines->Add(Format("%d %d",ARRAYOFCONST(((int)dwValue[0],(int)dwValue[1]))));
	}
else if (nAxes==3)
	{
	if (GetAxisMode(&dwValue[0],&dwValue[1],&dwValue[2],NULL))
		return(false);
	Memo1->Lines->Add(Format("%d %d %d",ARRAYOFCONST(((int)dwValue[0],(int)dwValue[1],(int)dwValue[2]))));
	}
else if (nAxes==4)
	{
	if (GetAxisMode(&dwValue[0],&dwValue[1],&dwValue[2],&dwValue[3]))
		return(false);
	Memo1->Lines->Add(Format("%d %d %d %d",ARRAYOFCONST(((int)dwValue[0],(int)dwValue[1],(int)dwValue[2],(int)dwValue[3]))));
	}

Memo1->Lines->Add("Processing SetVelocity(25,00) ...");
if (SetVelocity("25,00"))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing GetVelocity() ...");
if (GetVelocity(pReply[0]))
	return(false);
Memo1->Lines->Add(pReply[0]);

Memo1->Lines->Add("Processing SetAcceleration(10,00) ...");
if (SetAcceleration("10,00"))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing GetAcceleration() ...");
if (GetAcceleration(pReply[0]))
	return(false);
Memo1->Lines->Add(pReply[0]);

if (nControllerMode!=WP2_CONTROLLER_DELTA)
//Joystick functions are not available for Delta-PC
	{
	Memo1->Lines->Add("Processing JoystickEnable() ...");
	if (JoystickEnable())
		return(false);
	Memo1->Lines->Add("Done");

	Memo1->Lines->Add("Processing JoystickDisable() ...");
	if (JoystickDisable())
		return(false);
	Memo1->Lines->Add("Done");

	Memo1->Lines->Add("Processing SetJoystickVelocity(5,00) ...");
	if (SetJoystickVelocity("5,00"))
		return(false);
	Memo1->Lines->Add("Done");

	Memo1->Lines->Add("Processing GetJoystickVelocity() ...");
	if (GetJoystickVelocity(pReply[0]))
		return(false);
	Memo1->Lines->Add(pReply[0]);
	}

Memo1->Lines->Add("Processing SetOrigin() ...");
if (SetOrigin())
	return(false);
Memo1->Lines->Add("Done");

//MoveAbsolute()
if (nAxes==1)
	{
	Memo1->Lines->Add("Processing MoveAbsolute(10) ...");
	if (MoveAbsolute("10",NULL,NULL,NULL))
		return(false);
	}
else if (nAxes==2)
	{
	Memo1->Lines->Add("Processing MoveAbsolute(10,20) ...");
	if (MoveAbsolute("10","20",NULL,NULL))
		return(false);
	}
else if (nAxes==3)
	{
	Memo1->Lines->Add("Processing MoveAbsolute(10,20,0) ...");
	if (MoveAbsolute("10","20","0",NULL))
		return(false);
	}
else if (nAxes==4)
	{
	Memo1->Lines->Add("Processing MoveAbsolute(10,20,30,0) ...");
	if (MoveAbsolute("10","20","30","0"))
		return(false);
	}
while (true)
	{
	pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
	if (GetPos(pReply[0],pReply[1],pReply[2],pReply[3]))
		return(false);
	Memo1->Lines->Add(Format("Pos. %s %s %s %s",ARRAYOFCONST((pReply[0],pReply[1],pReply[2],pReply[3]))));
	if (GetStatus(&dwValue[0]))
		return(false);
	dwValue[0]=dwValue[0]&3;
	if ((dwValue[0]==0)||(dwValue[0]==2))
		break;
	}
Memo1->Lines->Add("Done");
pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
if (GetPos(pReply[0],pReply[1],pReply[2],pReply[3]))
	return(false);
Memo1->Lines->Add(Format("Pos. %s %s %s %s",ARRAYOFCONST((pReply[0],pReply[1],pReply[2],pReply[3]))));

//MoveRelative()
if (nAxes==1)
	{
	Memo1->Lines->Add("Processing MoveRelative(-5) ...");
	if (MoveRelative("-5",NULL,NULL,NULL))
		return(false);
	}
else if (nAxes==2)
	{
	Memo1->Lines->Add("Processing MoveRelative(-5,-10) ...");
	if (MoveRelative("-5","-10",NULL,NULL))
		return(false);
	}
else if (nAxes==3)
	{
	Memo1->Lines->Add("Processing MoveRelative(-5,-10,0) ...");
	if (MoveRelative("-5","-10","0",NULL))
		return(false);
	}
else if (nAxes==4)
	{
	Memo1->Lines->Add("Processing MoveRelative(-5,-10,-15,0) ...");
	if (MoveRelative("-5","-10","-15","0"))
		return(false);
	}
while (true)
	{
	pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
	if (GetPos(pReply[0],pReply[1],pReply[2],pReply[3]))
		return(false);
	Memo1->Lines->Add(Format("Pos. %s %s %s %s",ARRAYOFCONST((pReply[0],pReply[1],pReply[2],pReply[3]))));
	if (GetStatus(&dwValue[0]))
		return(false);
	dwValue[0]=dwValue[0]&3;
	if ((dwValue[0]==0)||(dwValue[0]==2))
		break;
	}
Memo1->Lines->Add("Done");
pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
if (GetPos(pReply[0],pReply[1],pReply[2],pReply[3]))
	return(false);
Memo1->Lines->Add(Format("Pos. %s %s %s %s",ARRAYOFCONST((pReply[0],pReply[1],pReply[2],pReply[3]))));

//MoveAbsoluteAutoReply()
if (nAxes==1)
	{
	Memo1->Lines->Add("Processing MoveAbsoluteAutoReply(15) ...");
	if (MoveAbsoluteAutoReply("15",NULL,NULL,NULL))
		return(false);
	}
else if (nAxes==2)
	{
	Memo1->Lines->Add("Processing MoveAbsoluteAutoReply(15,20) ...");
	if (MoveAbsoluteAutoReply("15","20",NULL,NULL))
		return(false);
	}
else if (nAxes==3)
	{
	Memo1->Lines->Add("Processing MoveAbsoluteAutoReply(15,20,0) ...");
	if (MoveAbsoluteAutoReply("15","20","0",NULL))
		return(false);
	}
else if (nAxes==4)
	{
	Memo1->Lines->Add("Processing MoveAbsoluteAutoReply(15,20,25,0) ...");
	if (MoveAbsoluteAutoReply("15","20","25","0"))
		return(false);
	}
pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
if (GetPos(pReply[0],pReply[1],pReply[2],pReply[3]))
	return(false);
Memo1->Lines->Add(Format("Pos. %s %s %s %s",ARRAYOFCONST((pReply[0],pReply[1],pReply[2],pReply[3]))));

if (nAxes==1)
	{
	Memo1->Lines->Add("Processing MoveRelativeAutoReply(-5) ...");
	if (MoveRelativeAutoReply("-5",NULL,NULL,NULL))
		return(false);
	}
else if (nAxes==2)
	{
	Memo1->Lines->Add("Processing MoveRelativeAutoReply(-5,-10) ...");
	if (MoveRelativeAutoReply("-5","-10",NULL,NULL))
		return(false);
	}
else if (nAxes==3)
	{
	Memo1->Lines->Add("Processing MoveRelativeAutoReply(-5,-10,0) ...");
	if (MoveRelativeAutoReply("-5","-10","0",NULL))
		return(false);
	}
else if (nAxes==4)
	{
	Memo1->Lines->Add("Processing MoveRelativeAutoReply(-5,-10,-15,0) ...");
	if (MoveRelativeAutoReply("-5","-10","-15","0"))
		return(false);
	}
pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
if (GetPos(pReply[0],pReply[1],pReply[2],pReply[3]))
	return(false);
Memo1->Lines->Add(Format("Pos. %s %s %s %s",ARRAYOFCONST((pReply[0],pReply[1],pReply[2],pReply[3]))));

Memo1->Lines->Add("Processing GetPosAxis() ...");
if (GetPosAxis(1,pReply[0]))
	return(false);
Memo1->Lines->Add(pReply[0]);

Memo1->Lines->Add("Processing GetPos() ...");
pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
if (GetPos(pReply[0],pReply[1],pReply[2],pReply[3]))
	return(false);
Memo1->Lines->Add(Format("Pos. %s %s %s %s",ARRAYOFCONST((pReply[0],pReply[1],pReply[2],pReply[3]))));

if (CheckBoxCalibrate->Checked==true)
	{
	Memo1->Lines->Add("Processing Calibrate ...");
	if (Calibrate())
		return(false);
	Memo1->Lines->Add("Done");
	Memo1->Lines->Add("Processing RangeMeasure ...");
	if (RangeMeasure())
		return(false);
	Memo1->Lines->Add("Done");
	}

Memo1->Lines->Add("Processing GetLimits() ...");
pReply[0][0]=pReply[1][0]=pReply[2][0]=pReply[3][0]=0;
pReply[4][0]=pReply[5][0]=pReply[6][0]=pReply[7][0]=0;
if (GetLimits(pReply[0],pReply[1],pReply[2],pReply[3],pReply[4],pReply[5],pReply[6],pReply[7]))
	return(false);
for (i=0;i<nAxes;i++)
	Memo1->Lines->Add(Format("Axis%d: Min=%s | Max=%s",ARRAYOFCONST((i+1,pReply[2*i],pReply[2*i+1]))));

//switch to asynchronous mode
//dwMode=2564+1048576;
dwMode=1051140;
dwBaudrate=ComboBoxBaudrate->Items->Strings[ComboBoxPort->ItemIndex].ToInt();
dwError=InitController((DWORD)nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCMSG,dwMode);
if (dwError)
	{
	ShowMessage(Format("InitController(%d,%d,%d,%d,%d) returned error %d",ARRAYOFCONST((nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,(int)dwBaudrate,(int)dwMode,(int)dwError))));
	return(false);
	}
Memo1->Lines->Add("Processing GetError in asynchronous mode ...");
//execute GetError in asynchronous mode
GetError(&dwValue[0]);

//switch back to synchronous mode
dwMode=1050884;
dwError=InitController((DWORD)nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCMSG,dwMode);
if (dwError)
	{
	ShowMessage(Format("InitController(%d,%d,%d,%d,%d) returned error %d",ARRAYOFCONST((nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,(int)dwBaudrate,(int)dwMode,(int)dwError))));
	return(false);
	}
return(true);
}

bool TFormWp2Demo::DoAlphaTest(int Axis)
{
DWORD	dwError;
DWORD	dwMode;
Memo1->Lines->Add(Format("\r\nAlpha test axis %d",ARRAYOFCONST((Axis))));
Sleep(1000);
Memo1->Lines->Add("Processing ClearParameterStackA() ...");
if (ClearParameterStackA(Axis))
	return(false);
Memo1->Lines->Add("Done");

/*not yet implemented
Memo1->Lines->Add("Processing GetParamsOnStackA() ...");
if (GetParamsOnStackA(&dwValue[0],Axis))
	return(false);
Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));
*/

Memo1->Lines->Add("Processing IdentifyA() ...");
if (IdentifyA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(pReply[0]);

Memo1->Lines->Add("Processing GetStatusA() ...");
if (GetStatusA(&dwValue[0],Axis))
	return(false);
Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));

Memo1->Lines->Add("Processing GetErrorA() ...");
if (GetErrorA(&dwValue[0],Axis))
	return(false);
Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));

Memo1->Lines->Add("Processing SetAxisModeA(1,Axis) ...");
if (SetAxisModeA(1,Axis))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing GetAxisModeA() ...");
if (GetAxisModeA(&dwValue[0],Axis))
	return(false);
Memo1->Lines->Add(Format("%d",ARRAYOFCONST(((int)dwValue[0]))));

Memo1->Lines->Add("Processing SetVelocityA(25,00) ...");
if (SetVelocityA("25,00",Axis))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing GetVelocityA() ...");
if (GetVelocityA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(pReply[0]);

Memo1->Lines->Add("Processing SetAccelerationA(10,00) ...");
if (SetAccelerationA("10,00",Axis))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing GetAccelerationA() ...");
if (GetAccelerationA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(pReply[0]);

Memo1->Lines->Add("Processing JoystickEnableA() ...");
if (JoystickEnableA(Axis))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing JoystickDisableA() ...");
if (JoystickDisableA(Axis))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing SetJoystickVelocityA(5,00) ...");
if (SetJoystickVelocityA("5,00",Axis))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing GetJoystickVelocityA() ...");
if (GetJoystickVelocityA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(pReply[0]);

Memo1->Lines->Add("Processing SetOriginA() ...");
if (SetOriginA(Axis))
	return(false);
Memo1->Lines->Add("Done");

Memo1->Lines->Add("Processing MoveAbsoluteA(20) ...");
if (MoveAbsoluteA("20",Axis))
	return(false);
while (true)
	{
	if (GetPosA(pReply[0],Axis))
		return(false);
	Memo1->Lines->Add(Format("Pos. %s",ARRAYOFCONST((pReply[0]))));
	if (GetStatusA(&dwValue[0],Axis))
		return(false);
	dwValue[0]=dwValue[0]&3;
	if ((dwValue[0]==0)||(dwValue[0]==2))
		break;
	}
Memo1->Lines->Add("Done");
if (GetPosA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(Format("Pos. %s",ARRAYOFCONST((pReply[0]))));

Memo1->Lines->Add("Processing MoveRelativeA(-10) ...");
if (MoveRelativeA("-10",Axis))
	return(false);
while (true)
	{
	if (GetPosA(pReply[0],Axis))
		return(false);
	Memo1->Lines->Add(Format("Pos. %s",ARRAYOFCONST((pReply[0]))));
	if (GetStatusA(&dwValue[0],Axis))
		return(false);
	dwValue[0]=dwValue[0]&3;
	if ((dwValue[0]==0)||(dwValue[0]==2))
		break;
	}
Memo1->Lines->Add("Done");
if (GetPosA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(Format("Pos. %s",ARRAYOFCONST((pReply[0]))));

Memo1->Lines->Add("Processing MoveAbsoluteAutoReplyA(15) ...");
if (MoveAbsoluteAutoReplyA("15",Axis))
	return(false);
if (GetPosA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(Format("Pos. %s",ARRAYOFCONST((pReply[0]))));

Memo1->Lines->Add("Processing MoveRelativeAutoReplyA(-10) ...");
if (MoveRelativeAutoReplyA("-10",Axis))
	return(false);
if (GetPosA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(Format("Pos. %s",ARRAYOFCONST((pReply[0]))));

Memo1->Lines->Add("Processing GetPosA() ...");
if (GetPosA(pReply[0],Axis))
	return(false);
Memo1->Lines->Add(Format("%s",ARRAYOFCONST((pReply[0]))));

if (CheckBoxCalibrate->Checked==true)
	{
	Memo1->Lines->Add("Processing CalibrateA() ...");
	if (CalibrateA(Axis))
		return(false);
	Memo1->Lines->Add("Done");
	Memo1->Lines->Add("Processing RangeMeasureA() ...");
	if (RangeMeasureA(Axis))
		return(false);
	Memo1->Lines->Add("Done");
	}

/*not yet implemented
Memo1->Lines->Add("Processing GetLimitsA() ...");
if (GetLimitsA(pReply[0],pReply[1],Axis))
	return(false);
Memo1->Lines->Add(Format("Min %s, Max %s",ARRAYOFCONST((pReply[0],pReply[1]))));
*/

//switch to asynchronous mode
dwMode=1051140;
dwBaudrate=ComboBoxBaudrate->Items->Strings[ComboBoxPort->ItemIndex].ToInt();
dwError=InitController((DWORD)nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCMSG,dwMode);
if (dwError)
	{
	ShowMessage(Format("InitController(%d,%d,%d,%d,%d) returned error %d",ARRAYOFCONST((nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,(int)dwBaudrate,(int)dwMode,(int)dwError))));
	return(false);
	}
Memo1->Lines->Add("Processing GetErrorA() in asynchronous mode ...");
//execute GetError in asynchronous mode
GetErrorA(&dwValue[0],Axis);

//switch back to synchronous mode
dwMode=1050884;
dwError=InitController((DWORD)nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCMSG,dwMode);
if (dwError)
	{
	ShowMessage(Format("InitController(%d,%d,%d,%d,%d) returned error %d",ARRAYOFCONST((nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,(int)dwBaudrate,(int)dwMode,(int)dwError))));
	return(false);
	}
return(true);
}

void __fastcall TFormWp2Demo::FormKeyDown(TObject */*Sender*/, WORD &Key,
	 TShiftState Shift)
{
if ((Key=='B')&&(Shift.Contains(ssCtrl)))
	{
	AbortCommand;
	Key=0;
	}
}
//---------------------------------------------------------------------------

void __fastcall TFormWp2Demo::Dispatch(void *Message)
{
switch(((PMessage)Message)->Msg)
	{
case(WMU_ASYNCMSG):
	{
	if (((PMessage)Message)->WParam==21)
		{
		ResetComm();
		ShowMessage("BREAK detected!");
		}
	else
		{
		char		*pReply;
		DWORD	dwError;
		pReply=new char[256];
		pReply[0]=0;
		dwError=GetReply(pReply);
		if (dwError==0)
			Memo1->Lines->Add(pReply);
		else
			ShowMessage(Format("Controller reply error >%d<",ARRAYOFCONST(((int)dwError))));
		delete[](pReply);
		if ((nControllerMode==WP2_CONTROLLER_DEFAULT)
				||(nControllerMode==WP2_CONTROLLER_DELTA)
				||(nControllerMode==WP2_CONTROLLER_TAURUS))
			ActiveControl=EditCommand;
		else
			{
			if (nTestAxis==1)
				ActiveControl=EditCommand;
			else
				ActiveControl=ButtonTest;
			}
		}
	break;
	}
default:
	TForm::Dispatch(Message);
	break;
	}
}

void __fastcall TFormWp2Demo::EditCommandKeyPress(TObject */*Sender*/, char &Key)
{
if (Key==13)
	{
	DWORD	dwLines;
	DWORD	dwError;
	pReply[0][0]=0;
	dwLines=CSpinEditLinesExpected->Value;
	if (CheckBoxAsyncMode->Checked==true)
		{
		dwError=InitController((DWORD)nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCMSG,1051140);
		if (dwError)
			{
			ShowMessage(Format("InitController(%d,%d,%d,%d,%d) returned error %d",ARRAYOFCONST((nControllerMode,(int)nAxes,(int)ComboBoxPort->ItemIndex+1,(int)dwError,(int)dwBaudrate,1051140))));
			Key=0;
			return;
			}
		}
	dwError=ExecuteCommand(EditCommand->Text.c_str(),dwLines,pReply[0]);
	if (dwError==0)
		{
		Memo1->Lines->Add(EditCommand->Text);
		if (pReply[0][0])
			Memo1->Lines->Add((AnsiString)pReply[0]);
		}
	else
		{
		ShowMessage(Format("ExecuteCommand(%s,%d,%s) returned =%d",
			ARRAYOFCONST((EditCommand->Text,(int)CSpinEditLinesExpected->Value,pReply[0],(int)dwError))));
		}
	if (CheckBoxAsyncMode->Checked==true)
		{
		dwError=InitController((DWORD)nControllerMode,nAxes,ComboBoxPort->ItemIndex+1,dwBaudrate,Handle,WMU_ASYNCMSG,1050884);
		if (dwError)
			ShowMessage(Format("InitController(%d,%d,%d,%d,%d) returned error %d",ARRAYOFCONST((nControllerMode,(int)nAxes,(int)ComboBoxPort->ItemIndex+1,(int)dwError,(int)dwBaudrate,1050884))));
		}
	Key=0;
	}
}

//---------------------------------------------------------------------------
void __fastcall TFormWp2Demo::FormResize(TObject */*Sender*/)
{
Memo1->Width=ClientWidth-2*Memo1->Left;
}
//---------------------------------------------------------------------------


void __fastcall TFormWp2Demo::ComboBoxControllerChange(TObject */*Sender*/)
{
if (ComboBoxController->ItemIndex==1)
	{
	nControllerMode=WP2_CONTROLLER_DELTA;
	CSpinEditAxes->MaxValue=4;
	CSpinEditAxes->Value=4;
	CSpinEditAxes->Enabled=true;
	ButtonTest->Caption="Test";
	EditCommand->Text="version";
	}
else if (ComboBoxController->ItemIndex==2)
	{
	nControllerMode=WP2_CONTROLLER_ALPHA;
	CSpinEditAxes->MaxValue=100;
	CSpinEditAxes->Value=4;
	CSpinEditAxes->Enabled=true;
	ButtonTest->Caption="Test axis 1";
	EditCommand->Text="1 nversion";
	}
else if (ComboBoxController->ItemIndex==3)
	{
	nControllerMode=WP2_CONTROLLER_TAURUS;
	CSpinEditAxes->MaxValue=1;
	CSpinEditAxes->Value=1;
	CSpinEditAxes->Enabled=false;
	ButtonTest->Caption="Test";
	EditCommand->Text="1 nversion";
	}
else if (ComboBoxController->ItemIndex==4)
	{
	nControllerMode=WP2_CONTROLLER_PEGASUS;
	CSpinEditAxes->MaxValue=100;
	CSpinEditAxes->Value=4;
	CSpinEditAxes->Enabled=true;
	ButtonTest->Caption="Test axis 1";
	EditCommand->Text="1 nversion";
	}
else if (ComboBoxController->ItemIndex==5)
	{
	nControllerMode=WP2_CONTROLLER_ORION;
	CSpinEditAxes->MaxValue=100;
	CSpinEditAxes->Value=4;
	CSpinEditAxes->Enabled=true;
	ButtonTest->Caption="Test axis 1";
	EditCommand->Text="1 nversion";
	}
else if (ComboBoxController->ItemIndex==6)
	{
	nControllerMode=WP2_CONTROLLER_CORVUS;
	CSpinEditAxes->MaxValue=3;
	CSpinEditAxes->Value=3;
	CSpinEditAxes->Enabled=true;
	ButtonTest->Caption="Test";
	EditCommand->Text="version";
	}
else
	{
	nControllerMode=WP2_CONTROLLER_DEFAULT;
	CSpinEditAxes->MaxValue=3;
	CSpinEditAxes->Value=3;
	CSpinEditAxes->Enabled=true;
	ButtonTest->Caption="Test";
	EditCommand->Text="version";
	}
SetupComboBoxBaudrate(nControllerMode);
}
//---------------------------------------------------------------------------

void TFormWp2Demo::SetupComboBoxBaudrate(int nMode)
{
ComboBoxBaudrate->Items->Clear();
ComboBoxBaudrate->Items->Add("19200");
ComboBoxBaudrate->Items->Add("9600");
ComboBoxBaudrate->Items->Add("4800");
ComboBoxBaudrate->Items->Add("2400");
ComboBoxBaudrate->Items->Add("1200");
switch(nMode)
	{
case(WP2_CONTROLLER_DELTA):
	ComboBoxBaudrate->ItemIndex=ComboBoxBaudrate->Items->IndexOf("9600");
	ComboBoxBaudrate->Enabled=false;
	break;
case(WP2_CONTROLLER_CORVUS):
	ComboBoxBaudrate->Items->Insert(0,"57600");
	ComboBoxBaudrate->Items->Insert(0,"115200");
	ComboBoxBaudrate->ItemIndex=ComboBoxBaudrate->Items->IndexOf("115200");
	ComboBoxBaudrate->Enabled=true;
	break;
case(WP2_CONTROLLER_ALPHA):
case(WP2_CONTROLLER_TAURUS):
case(WP2_CONTROLLER_PEGASUS):
case(WP2_CONTROLLER_ORION):
case(WP2_CONTROLLER_DEFAULT):
	ComboBoxBaudrate->ItemIndex=ComboBoxBaudrate->Items->IndexOf("9600");
	ComboBoxBaudrate->Enabled=true;
	break;
default:
	ComboBoxBaudrate->ItemIndex=ComboBoxBaudrate->Items->IndexOf("19200");
	ComboBoxBaudrate->Enabled=true;
	break;
	}
}

