// Wp2DemoDlg.h : header file
//

#define		WMU_ASYNCMSG		WM_USER+10

#define		WP2_CONTROLLER_DEFAULT	1
#define		WP2_CONTROLLER_DELTA	2
#define		WP2_CONTROLLER_ALPHA	4
#define		WP2_CONTROLLER_TAURUS	8
#define		WP2_CONTROLLER_PEGASUS	16
#define		WP2_CONTROLLER_ORION	32
#define		WP2_CONTROLLER_CORVUS	64


/////////////////////////////////////////////////////////////////////////////
// CWp2DemoDlg dialog

class CWp2DemoDlg : public CDialog
{
// Construction
public:
	CWp2DemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CWp2DemoDlg)
	enum { IDD = IDD_WP2DEMO_DIALOG };
	CComboBox	m_ComboBaudrate;
	CComboBox	m_ComboPort;
	CComboBox	m_ComboAxes;
	CComboBox	m_ComboController;
	CButton	m_Execute;
	CListBox	m_ListData;
	CButton	m_Test;
	CButton	m_OpenController;
	CButton	m_InitController;
	CButton	m_CloseController;
	CString	m_EditCommand;
	int		m_EditLines;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWp2DemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	HINSTANCE	hWp2CommDll;
	DWORD		dwAxes;
	DWORD		dwControllerMode;
	void		SetupComboBoxBaudrate(int nMode);


	// Generated message map functions
	//{{AFX_MSG(CWp2DemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtoninit();
	afx_msg void OnClose();
	afx_msg void OnButtonopen();
	afx_msg void OnButtonclose();
	afx_msg void OnButtontest();
	afx_msg void OnButtonexecute();
	afx_msg void OnSelchangeComboController();
	//}}AFX_MSG
	afx_msg	LRESULT	OnAsyncMsg(WPARAM wParam,LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};
