'VBScript demo, displaying the position of the controller in a message box
'To use with alpha controllers
'See Axes, Port, Baudrate in Wp2Init() an adjust them if necessary

Dim vbOKCancel
Dim vbInformation
Dim vbCancel
Dim Wp2Comm
Dim RetValue1
Dim RetValue2

vbOKCancel=1
vbInformation=64
vbCancel=2

'load Wp2CommX
Set Wp2Comm=WScript.CreateObject("Wp2Comm.Wp2CommX")

'Alpha-Controller(4) with 4 axes at COM2, 19200 Baud
RetValue1=Wp2Comm.Wp2Init(4,4,2,19200)

'Wp2Init returns the port is succesful
if RetValue1<>1 Then
	WScript.Echo("Wp2init failed")
	WScript.Quit()
	End If

'activate joystick
Wp2Comm.Wp2ExecuteCommand "1 2 nj",0

While True
	If VBSShowPos()<>0 Then
		WScript.Quit()
		End If
	Wend
WScript.Quit()

'get position values and display them
Function VBSShowPos()
Dim Continue
Dim WSHShell
Dim Msg
Dim A1
Dim A2
Dim A3
Dim A4
RetValue2=Wp2Comm.Wp2GetPosA(1)
If RetValue2<>0 Then
	WScript.Echo("Wp2GetPosA(1) failed")
	VBSShowPos=1
	Exit Function
	End If
A1=Wp2Comm.Pos1
RetValue2=Wp2Comm.Wp2GetPosA(2)
If RetValue2<>0 Then
	WScript.Echo("Wp2GetPosA(2) failed")
	VBSShowPos=1
	Exit Function
	End If
A2=Wp2Comm.Pos1
RetValue2=Wp2Comm.Wp2GetPosA(3)
If RetValue2<>0 Then
	WScript.Echo("Wp2GetPosA(3) failed")
	VBSShowPos=1
	Exit Function
	End If
A3=Wp2Comm.Pos1
RetValue2=Wp2Comm.Wp2GetPosA(4)
If RetValue2<>0 Then
	WScript.Echo("Wp2GetPosA(4) failed")
	VBSShowPos=1
	Exit Function
	End If
A4=Wp2Comm.Pos1
Msg="Axi1="+A1+", Axis2="+A2+", Axis3="+A3+", Axis4="+A4+". Continue?"
Continue=MsgBox(Msg,vbOKCancel+vbInformation,"Wp2Comm")
If Continue=vbCancel Then
	VBSShowPos=1
Else
	VBSShowPos=0
End If
End Function
